#==============================================================================#
#                        Copyright 2022-2024 ArchaicSoft                       #
#                                                                              #
# Boost Software License - Version 1.0 - August 17th, 2003                     #
#                                                                              #
# Permission is hereby granted, free of charge, to any person or organization  #
# obtaining a copy of the software and accompanying documentation covered by   #
# this license (the "Software") to use, reproduce, display, distribute,        #
# execute, and transmit the Software, and to prepare derivative works of the   #
# Software, and to permit third-parties to whom the Software is furnished to   #
# do so, all subject to the following:                                         #
#                                                                              #
# The copyright notices in the Software and this entire statement, including   #
# the above license grant, this restriction and the following disclaimer,      #
# must be included in all copies of the Software, in whole or in part, and     #
# all derivative works of the Software, unless such copies or derivative       #
# works are solely in the form of machine-executable object code generated by  #
# a source language processor.                                                 #
#                                                                              #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   #
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     #
# FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT    #
# SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE    #
# FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,  #
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER  #
# DEALINGS IN THE SOFTWARE.                                                    #
#==============================================================================#

@tool extends Control

var _initialized : bool

func _ready() -> void:
	_initialized = true
	
	_on_visibility_changed()

func _on_visibility_changed():
	if not (_initialized and self.visible): return
	_settings_visibility_changed()
	_setup_visibility_changed()

#====================#
#  Project Settings  #
#====================#

const resolutions : Array[Vector2i] = [
	Vector2i.ZERO, Vector2i.ZERO,
	Vector2i(640,   480),
	Vector2i(800,   600),
	Vector2i(1280,  720),
	Vector2i(1680, 1050),
	Vector2i(1920, 1080)
]

enum pixel_snap {
	none,
	transform,
	vertices,
	both
}

@onready var btn_window_size: OptionButton = $"Align/Grid Settings/Window Size Button"
@onready var btn_texture:     Button       = $"Align/Grid Settings/Texture Button"
@onready var btn_pixel:       Button       = $"Align/Grid Settings/Pixel Button"
@onready var btn_xr:          Button       = $"Align/Grid Settings/XR Button"

func get_setting(setting: String) -> Variant:
	return ProjectSettings.get_setting(setting)
func set_setting(setting: String, value: Variant) -> void:
	ProjectSettings.set_setting(setting, value)

func _settings_visibility_changed() -> void:
	# window size
	btn_window_size.select(0)
	for size in btn_window_size.item_count:
		if _is_resolution(resolutions[size]):
			btn_window_size.select(size); break
	
	# texture blur enabled
	btn_texture.select(_get_texture_setting())
	
	# pixel snap enabled
	btn_pixel.select(_get_pixel_snap_settings())
	
	# xr enabled
	btn_xr.set_pressed_no_signal(_is_xr_enabled())
	btn_xr.text = "Disable      " if \
		btn_xr.button_pressed else "Enable      "

func _is_resolution(size: Vector2i) -> bool:
	return (
		size.x == ProjectSettings.get_setting("display/window/size/viewport_width") and
		size.y == ProjectSettings.get_setting("display/window/size/viewport_height")
	)
func _on_window_size_button_item_selected(index: int) -> void:
	var size := resolutions[index]
	ProjectSettings.set_setting("display/window/size/viewport_width", size.x)
	ProjectSettings.set_setting("display/window/size/viewport_height", size.y)
	ProjectSettings.save()

func _get_texture_setting() -> int:
	return get_setting(
		"rendering/textures/canvas_textures/default_texture_filter")
func _on_texture_button_item_selected(index: int) -> void:
	ProjectSettings.set_setting(
		"rendering/textures/canvas_textures/default_texture_filter",
		index
	); ProjectSettings.save()

func _get_pixel_snap_settings() -> int:
	return (1 & int(get_setting("rendering/2d/snap/snap_2d_transforms_to_pixel")) |
		(1 << int(get_setting("rendering/2d/snap/snap_2d_vertices_to_pixel"))))
func _on_pixel_button_item_selected(index: int) -> void:
	set_setting("rendering/2d/snap/snap_2d_transforms_to_pixel", bool(index & 1))
	set_setting("rendering/2d/snap/snap_2d_vertices_to_pixel", bool(index >> 1))
	ProjectSettings.save()

func _is_xr_enabled() -> bool:
	return (get_setting("xr/openxr/enabled") and
		get_setting("xr/shaders/enabled"))
func _on_xr_button_toggled(toggled_on: bool) -> void:
	btn_xr.text = "Disable      " if \
		toggled_on else "Enable      "
	
	set_setting("xr/openxr/enabled", toggled_on)
	set_setting("xr/shaders/enabled", toggled_on)
	ProjectSettings.save()

#=================#
#  Project Setup  #
#=================#

func _setup_visibility_changed() -> void:
	_migrate_file_direct_settings()

func _append_git_ignore(content: String) -> void:
	var file := FileAccess.open("res://.gitignore", FileAccess.READ_WRITE)
	var contents = file.get_as_text()
	
	# scroll to end of file
	file.seek_end()
	
	# add content
	if not contents.contains(content):
		file.store_line(content)
	
	# complete the write and finish up
	file.close()

func _get_png_or_svg(path: String) -> String:
	var file : String
	
	file = path + ".svg"
	if FileAccess.file_exists(file): return file
	
	file = path + ".png"
	if FileAccess.file_exists(file): return file
	
	return ""

func _migrate_file_direct_settings() -> void:
	var file : String
	
	# set icon data
	file = _get_png_or_svg("res://assets/images/system/icon")
	if file != "": set_setting("application/config/icon", file)
	
	file = "res://assets/images/system/icon.icns"
	if FileAccess.file_exists(file):
		set_setting("application/config/macos_native_icon", file)
	
	file = "res://assets/images/system/icon.ico"
	if FileAccess.file_exists(file):
		set_setting("application/config/windows_native_icon", file)
	
	# set splash screen
	file = _get_png_or_svg("res://assets/images/system/splash")
	if file != "":
		set_setting("application/boot_splash/image", file)
		set_setting("application/boot_splash/show_image", true)
	
	# set mouse cursor image
	file = _get_png_or_svg("res://assets/images/system/cursor")
	if file != "": set_setting("display/mouse_cursor/custom_image", file)

func _on_format_all_pressed():
	_append_git_ignore("**/.godot")
	
	_on_directory_layout_pressed()
	_on_export_templates_pressed()
	_on_resources_pressed()

func _on_directory_layout_pressed():
	var directories : Array[String] = [
		# base paths
		".export", "addons", "assets", "extensions",
		"resources", "scenes", "scripts", "translations",
		
		# export paths
		".export/linux", ".export/android",
		".export/win32", ".export/win64",
		".export/macos", ".export/ios",
		
		# asset base paths
		"assets/audio", "assets/fonts", "assets/images", "assets/models",
		
		# audio paths
		"assets/audio/music", "assets/audio/sound",
		
		# image paths
		"assets/images/characters", "assets/images/gui",
		"assets/images/system", "assets/images/tilesets",
		
		# resource paths
		"resources/materials", "resources/openxr", "resources/themes",
		
		# scene paths
		"scenes/screens",
		
		# script paths
		"scripts/templates"
	]
	
	for dir in directories:
		var path : String = "res://" + dir
		if not DirAccess.dir_exists_absolute(path):
			DirAccess.make_dir_recursive_absolute(path)
	
	#-----------------#
	# Relocate Assets #
	#-----------------#
	
	var files : PackedStringArray = DirAccess.get_files_at("res://")
	
	# move source files
	for file in files:
		if file.ends_with(".gd"):
			DirAccess.rename_absolute(file, "res://scripts/" + file.get_file())
	
	var file : String
	
	# move project icon
	file = "res://icon.png"
	if FileAccess.file_exists(file):
		DirAccess.rename_absolute(file, "res://assets/images/system/icon.png")
	
	file = "res://icon.svg"
	if FileAccess.file_exists(file):
		DirAccess.rename_absolute(file, "res://assets/images/system/icon.svg")
	
	#=========================#
	# Rebind Script Templates #
	#=========================#
	var template_path   : String = get_setting("editor/script/templates_search_path")
	var template_target : String = "res://scripts/templates" 
	
	# ensure directory exists
	if template_path != template_target:
		set_setting("editor/script/templates_search_path", template_target)
		
		# migrate files
		DirAccess.rename_absolute(template_path, template_target)

func _on_export_templates_pressed():
	var path : String = "res://export_presets.cfg"
	if not FileAccess.file_exists(path):
		var template_file : String = "res://addons/asfw/_/export_presets.cfg"
		DirAccess.copy_absolute(template_file, path)
	
	path = "res://debug.keystore"
	if not FileAccess.file_exists(path):
		var template_file : String = "res://addons/asfw/_/debug.keystore"
		DirAccess.copy_absolute(template_file, path)
	
	# add path to gitignore
	_append_git_ignore("**/.export")

func _on_resources_pressed():
	var cd   : String = "res://"
	var path : String
	
	# enter resources directory if it exists
	if DirAccess.dir_exists_absolute(cd + "resources"):
		cd += "resources/"
	
	# audio layout
	path  = cd + "audio_layout.tres"
	if not FileAccess.file_exists(path):
		var resource = AudioBusLayout.new()
		ResourceSaver.save(resource, path)
		set_setting("audio/buses/default_bus_layout", path)
	
	# environment
	path = cd + "environment.tres"
	if not FileAccess.file_exists(path):
		var resource = Environment.new()
		resource.background_mode = Environment.BG_SKY
		resource.sky = Sky.new()
		resource.sky.sky_material = ProceduralSkyMaterial.new()
		ResourceSaver.save(resource, path)
		set_setting("rendering/environment/defaults/default_environment", path)
	
	# themes directory
	if not DirAccess.dir_exists_absolute(cd + "themes"):
		DirAccess.make_dir_recursive_absolute(cd + "themes")
	
	# theme
	path = cd + "themes/default.tres"
	if not FileAccess.file_exists(path):
		var resource = Theme.new()
		ResourceSaver.save(resource, path)
		set_setting("gui/theme/custom", path)
	
	# set openxr action map path
	set_setting("xr/openxr/default_action_map", "res://resources/openxr/action_map.tres")
